#!/usr/bin/perl

use warnings;
use strict;
use Date::Manip;
use DBI;

my $user = "clamstat";
my $pw = "1clamstat2";
my $database = "clamstat";
my $serverName = "localhost";
my $serverPort = "3306";
my $log_file = '/var/log/maillog';
my $year = "";	

my $ibh = DBI->connect("DBI:mysql:$database;host=$serverName;port=$serverPort",$user,$pw);
die "Unable to connect: ".$DBI::errstr."\n" unless (defined $ibh);

my ($email, %ip_addr, $ip_addr, $sender, $recipient, $message_id, $datetime, $server, $virusname, $dateyear);

open(FILE, "$log_file") or die("Error opening $log_file: $!\n");
while(<FILE>) {


                if (/(?:\d|\D)+sendmail\[(?:\d)+\]:\s((?:\w)+):(?:\d|\D)+\[(\d+\.\d+\.\d+\.\d+)\]/) {
                        $message_id = $1;
                        $ip_addr = $2;
                        $email->{$message_id}{ip_addr} = $ip_addr;

#Sample log line
#Feb  7 04:23:14 ns1b sendmail[21106]: j179LwN4021106: from=<identifdep_ref99318273803@smithbarney.com>, size=12145, class=0, nrcpts=1, msgid=<200502070922.j179LwN4021106@ns1b.hillsboroughcounty.org>, proto=SMTP, daemon=MTA, relay=[220.174.160.202]

                }
                elsif (/((?:\d|\D)+)\s((?:\d|\D)+)\sclamav-milter\[(?:\d)+\]:\s((?:\w)+):\s(?:\d|\D)+:\s((?:\d|\D)+)\sIntercepted virus from \<((?:\d|\D)+)\> to \<((?:\d|\D)+)\>/) {

#Sample log line
#Feb  7 04:23:14 ns1b clamav-milter[31063]: j179LwN4021106: /tmp/clamav-16ea710a4af0a812/msg.pvpoao: HTML.Phishing.Bank-1 Intercepted virus from <identifdep_ref99318273803@smithbarney.com> to <hildsk@hillsboroughcounty.org>
			
			$dateyear = $year . " " . $1;
			$datetime = UnixDate("$dateyear",'%Y-%m-%d %H:%M:%S');
			$server = $2;
                        $message_id = $3;
                        $virusname = $4;
                        $sender = $5;
                        $recipient = $6;

                        $email->{$message_id}{datetime} = $datetime;
                        $email->{$message_id}{virusname} = $virusname;
                        $email->{$message_id}{sender} = $sender;
                        $email->{$message_id}{recipient} = $recipient;
                        $email->{$message_id}{server} = $server;
                }

}
close(FILE);

foreach $message_id ( keys  %{ $email } ) {
                if ( $email->{$message_id}{virusname} ) {
			$datetime = $email->{$message_id}{datetime};
                        $virusname = $email->{$message_id}{virusname};
                        $sender = $email->{$message_id}{sender};
                        $recipient = $email->{$message_id}{recipient};
                        $ip_addr = $email->{$message_id}{ip_addr};
                        $server = $email->{$message_id}{server};
			my $results=$ibh->do("INSERT INTO logs VALUES ('$message_id', '$datetime', '$virusname', '$sender', '$recipient', '$ip_addr', '$server') ");
                }
}


$ibh->disconnect;
