#!/usr/bin/perl


use warnings;
use strict;
use Term::ReadKey;
use DBI;

my $aref;
my $database_present = "2";
my $tables_present = "2";

print "This scripts creates the clamstat database and tables on a Mysql server\n";
print "Enter user for connect to your database: ";
chomp (my $user = <STDIN>);

print "Enter password for $user to connect to your database: ";
#Conceal the password from the prompt
ReadMode 2;
chomp (my $pw = <STDIN>);
ReadMode 0;

my $database = "mysql";
my $dbh = DBI->connect("DBI:mysql:$database",$user,$pw);
die "Unable to connect: ".$DBI::errstr."\n" unless (defined $dbh);

#See if the clamstat database is available
our $cdb=$dbh->prepare(q{SHOW DATABASES}) or
	die "Unable to prepare show databases: ". $dbh->errstr."\n";
$cdb->execute or
	die "Unable to exec show databases: ". $dbh->errstr."\n";

while ($aref = $cdb->fetchrow_arrayref) {
	if ("$aref->[0]" eq "clamstat") {
		$database_present = "1";
	}
}

$cdb->finish;

#Create the clamstat database unless it's already there
if ($database_present eq "2") {
	my $dth=$dbh->prepare(q{CREATE DATABASE clamstat}) or
        	die "Unable to prepare show databases: ". $dbh->errstr."\n";
	$dth->execute or
        	die "Unable to exec show databases: ". $dbh->errstr."\n";
	$dth->finish;
	print "\n Created Database...";
} else {
print "\n Database present...";
}


#Disconnect from database
$dbh->disconnect;


$database = "clamstat";
my $sbh = DBI->connect("DBI:mysql:$database",$user,$pw);
die "Unable to connect: ".$DBI::errstr."\n" unless (defined $sbh);

#See if the logs table is available
our $ctbl=$sbh->prepare(q{SHOW TABLES FROM clamstat}) or
	die "Unable to prepare show databases: ". $sbh->errstr."\n";
$ctbl->execute or
	die "Unable to exec show databases: ". $sbh->errstr."\n";

while ($aref = $ctbl->fetchrow_arrayref) {
	if ("$aref->[0]" eq "logs") {
		$tables_present = "1";
	}
}

$ctbl->finish;


#Create the clamstat tables
if ($tables_present eq "2") {
	my $vth=$sbh->prepare(q{CREATE TABLE logs ( messageid CHAR(32) PRIMARY KEY, time datetime NOT NULL, virusname CHAR(32) NOT NULL, fromaddr CHAR(32), toaddr CHAR(32), ipaddr CHAR(32) NOT NULL, server CHAR(32) NOT NULL ) } ) or
        	die "Unable to prepare show databases: ". $sbh->errstr."\n";

	$vth->execute or
        	die "Unable to exec show databases: ". $sbh->errstr."\n";
	$vth->finish;
	print "\n Created Tables...";
	my $results=$sbh->prepare(q{CREATE INDEX time_index ON logs (time) }) or
		die "Unable to prepare our query: ".$sbh->errstr."\n";
	$results->execute or die "Unable to execute our query: ".$sbh->errstr."\n";
	$results->finish;
	print "\n Indexed time table...";

} else {
print "\n Tables present...";
}



#Disconnect from database
$sbh->disconnect;

print "\n Done. \n";
